/******************************************************************************
*
*    C++ source code for GameBender for Shadowcaster
*
*    Compile with Microsoft Visual C++ version 1.5
*
*    version 0.01  12/06/94
*    version 0.02  03/20/95  text output for successful case changed slightly
*
*******************************************************************************
*
*    Copyright 1994, 1995 Robert Sacks and Associates, Inc.
*
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>


/****************************************************************************/
/*** STATIC AND GLOBAL DATA *************************************************/
/****************************************************************************/

int  iGameNumber ;
char acVersion [] = "0.02" ;
int  iExtraPower = 0 ;


/****************************************************************************/
/*** CODE *******************************************************************/
/****************************************************************************/

/* ------------------------------------------------------------------------ *\
   REPLACE_FILE_BYTES
   ------------------
   Returns: -1 on error; 0 on success
\* ------------------------------------------------------------------------ */

int replace_file_bytes ( FILE * psFile , long lLocation , 
                          unsigned char * pbNew ,  unsigned uQty )
{
   int iRetVal ;

   if ( fseek ( psFile , lLocation , 0 ) )
      return -1 ;

   size_t RetVal = fwrite ( pbNew , sizeof ( unsigned char ) , uQty , psFile ) ;

   if ( RetVal != uQty )
   {
      printf ( "Oops!  Something's not working.  Your game was NOT changed.\n" ) ;
      return -1 ;
   }

   return 0 ;
}


/* ------------------------------------------------------------------------ *\
   RAISE_ANIMAL 
\* ------------------------------------------------------------------------ */

int raise_animal ( FILE * psFile , long lPosition )
{
   int iRetVal ;

   unsigned char * pcPowerQty ;

   unsigned char acRegPower []   = "\xf0" "\x00" ;
   unsigned char acExtraPower [] = "\xf0" "\x40" ;

 
  if ( iExtraPower == 1 )
      pcPowerQty = acExtraPower ;

   else
      pcPowerQty = acRegPower ;

   // EXPERIENCE 
   iRetVal = replace_file_bytes ( psFile ,
                                  lPosition ,  // LOCATION
                                  (unsigned char * ) "\x00" "\x00" "\x00" "\x06" ,
                                  4 
                                ) ;
   if ( iRetVal )
      return ( iRetVal ) ;

   // CURRENT POWER
   iRetVal = replace_file_bytes ( psFile ,
                                  lPosition + ( 18632L - 18020L ) , // LOCATION
                                  &pcPowerQty [0],
                                  sizeof ( pcPowerQty ) / sizeof ( unsigned char ) 
                                ) ;
   if ( iRetVal )
      return ( iRetVal ) ;

   // MAX POWER
   iRetVal = replace_file_bytes ( psFile ,
                                  lPosition + ( 18636L - 18020L ) , // LOCATION
                                  &pcPowerQty[0] ,
                                  sizeof ( pcPowerQty ) / sizeof ( unsigned char ) 
                                ) ;
   if ( iRetVal )
      return ( iRetVal ) ;

   // CURRENT LIFE 
   iRetVal = replace_file_bytes ( psFile ,
                                  lPosition + ( 18008L - 18020L ) , // LOCATION
                                  &pcPowerQty[0] ,
                                  sizeof ( pcPowerQty ) / sizeof ( unsigned char ) 
                                ) ;

   if ( iRetVal )
      return ( iRetVal ) ;

   // MAX LIFE 
   iRetVal = replace_file_bytes ( psFile ,
                                  lPosition + ( 18288L - 18020L ) , // LOCATION
                                  &pcPowerQty[0] ,
                                  sizeof ( pcPowerQty ) / sizeof ( unsigned char ) 
                                ) ;
   if ( iRetVal )
      return ( iRetVal ) ;

   return ( 0 ) ;
}


/* ------------------------------------------------------------------------ *\
   MAIN
\* ------------------------------------------------------------------------ */

void main ( int iArg , char ** ppcArg )
{
   if ( iArg >= 2 )
      if ( ppcArg [1] [0] == '-' || ppcArg [1] [0] == '/' )
         if ( ppcArg [1] [1] == 'x' || ppcArg [1] [1] == 'X' )
            iExtraPower = 1 ;

   printf ( "\nGameBender(TM) version " ) ;
   printf ( "%s" , acVersion ) ;
   printf ( " for Shadowcaster(TM).\n\n" ) ;

   printf ( "Copyright 1994, 1995 Robert Sacks and Associates, Inc.\n" ) ;
   printf ( "Send email to Compuserve 72323,3456.\n\n" ) ;

   printf ( "This program changes a saved Shadowcaster(TM) game in two ways:\n\n" ) ;

   printf ( "1.  All stats increase to maximum.\n" ) ;
   printf ( "2.  Your character becomes able to transform into all creatures.\n" ) ;

   for (;;)
   {
      printf ( "\n   Which game do you want to change?\n" ) ;
      printf (   "     Type 1, 2, 3, 4, or Q to quit.\n\n" ) ;

      int iChar = _getche () ;

      if ( iChar == 'q' || iChar == 'Q' )
         exit ( 0 ) ;

      printf ( "\n\n" ) ;

      iGameNumber = iChar - '0' ;

      if ( iGameNumber < 1 || 4 < iGameNumber )
         continue ;

      else
         break ;
   }

   char acTemp [100] ;

   _itoa ( iGameNumber, acTemp , 10 ) ;

   char acFileName [100] ;

   strcpy ( acFileName, "s" ) ;
   strcat ( acFileName, acTemp ) ;
   strcat ( acFileName, "\\game.sav" ) ;

   FILE * psFile = fopen ( acFileName , "r+b" ) ;

   if ( psFile == 0 )
   {
      printf ( "Oops!  Can't open file!  Your game was NOT changed.\n\n" ) ;

      printf ( "Before you run this program, you must:\n\n" ) ;

      printf ( "1.  Copy this program (GAMEBEND.EXE) to the directory with Shadowcaster(TM).\n" ) ;
      printf ( "2.  Play Shadowcaster(TM) and use it to save the game you want to change.\n\n" ) ;

      return ;
   }

   else
   {
      printf ( "Changing saved game number %d...\n" , iGameNumber ) ;

      if ( iExtraPower == 1 )
         printf ( "Extra power!!!\n" ) ;

      // ADD ANIMALS
      int iRetVal = replace_file_bytes ( psFile ,
                                         18554L,  // LOCATION
                                         ( unsigned char * ) "\x01" "\x01" "\x01" "\x01" "\x01" "\x01" ,  // VALUE
                                         6 // QTY
                                       ) ;
      if ( iRetVal )
         return ;

      iRetVal = raise_animal ( psFile , 18020L ) ;
      if ( iRetVal ) return ;

      iRetVal = raise_animal ( psFile , 18060L ) ;
      if ( iRetVal ) return ;

      iRetVal = raise_animal ( psFile , 18100L ) ;
      if ( iRetVal ) return ;

      iRetVal = raise_animal ( psFile , 18140L ) ;
      if ( iRetVal ) return ;

      iRetVal = raise_animal ( psFile , 18180L ) ;
      if ( iRetVal ) return ;

      iRetVal = raise_animal ( psFile , 18220L ) ;
      if ( iRetVal ) return ;


      if ( iRetVal )
         return ;

      else
      {
         printf ( "Game %d was changed!\n\n" , iGameNumber ) ;
         printf ( "To play changed game, start Shadowcaster and load game %d.\n" , iGameNumber ) ;
      }
   }

   fclose ( psFile ) ;
}

/*****************************************************************************/
/*** END OF FILE *************************************************************/
/*****************************************************************************/
